/************************************************************************
    frap/defrap - fractal image compressor/decompressor
    Copyright (C) 1997-2000 Matthias Ruhl

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    The author can be contacted at:
      MIT Laboratory for Computer Science
      200 Technology Square
      Cambridge, MA 02139
      USA
    or via e-mail: ruhl@theory.lcs.mit.edu
*************************************************************************/

#ifndef FILEIO_H
#define FILEIO_H

#define SYMBOLS 7
#define NUM 100
#define BIGINTLEN 20
#define BIGINTBITS 29
#define WBITS 18

#define max(a,b) ((a)<(b)?(b):(a))

typedef int bigint[BIGINTLEN];

extern int packpos;

int unpack(int bits, FILE *inp);
void pack(int val, int bits, FILE *out);
void arith_init(int enc, FILE *file);
void arith_code(char *c, int len, int *freq);

#endif
